{{ $appSection := "arcgisBackend" -}}
{{ $appName := (index . "Values" $appSection "name") -}}
{{- if index . "Values" $appSection "enabled" -}}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ $appName }}
  labels:
    app.kubernetes.io/name: {{ $appName }}
    backstage.io/kubernetes-id: {{ $appName }}
    {{- include "lkod.labels" . | nindent 4 }}
  annotations:
    {{- include "lkod.annotations" . | nindent 4 }}
spec:
  replicas: {{ index . "Values" $appSection "replicas" }}
  selector:
    matchLabels:
      app.kubernetes.io/name: {{ $appName }}
      {{- include "lkod.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      labels:
        app.kubernetes.io/name: {{ $appName }}
        backstage.io/kubernetes-id: {{ $appName }}
        {{- include "lkod.labels" . | nindent 8 }}
        {{- if .Values.podLabels }}
        {{- include "common.tplvalues.render" ( dict "value" .Values.podLabels "context" $ ) | nindent 8 }}
        {{- end }}
      annotations:
        {{- include "lkod.annotations" . | nindent 8 }}
        {{- if (index . "Values" $appSection "podAnnotations") }}
        {{- include "common.tplvalues.render" ( dict "value" (index . "Values" $appSection "podAnnotations") "context" $ ) | nindent 8 }}
        {{- end }}
    spec:
      automountServiceAccountToken: false
      {{- include "lkod.imagePullSecrets" (list . .Values.global.imagePullSecrets ) | nindent 6 }}
      containers:
        - name: arcgis-backend
          image: {{ include "lkod.imageName" (list . $appSection) | quote }}
          imagePullPolicy: {{ .Values.global.pullPolicy }}
          ports:
            - containerPort: {{ index . "Values" $appSection "port" }}
          env:
            - name: ACTIVITY_LOG_ENABLED
              value: "true"
            - name: LKOD_CATALOG_URL
              value: https://{{ index . "Values" $appSection "catalogUrl" }}
            - name: DEFAULT_TIMEZONE
              value: "Europe/Prague"
            - name: REFRESH_DATA_CRON
              value: {{ index . "Values" $appSection "cron" | quote }}
            - name: POSTGRES_CONN
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.global.secretName }}
                  key: postgres-arcgis-conn
            - name: POSTGRES_SCHEMA
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.global.secretName }}
                  key: postgres-schema
            - name: POSTGRES_IDLE_TIMEOUT
              value: {{ index . "Values" $appSection "postgres" "idleTimeout" | quote }}
            - name: POSTGRES_MIN_CONNECTIONS
              value: {{ index . "Values" $appSection "postgres" "minConnections" | quote }}
            - name: POSTGRES_MAX_CONNECTIONS
              value: {{ index . "Values" $appSection "postgres" "maxConnections" | quote }}
            - name: LOG_LEVEL
              value: {{ index . "Values" $appSection "logLevel" | quote }}
          resources:
            {{ index . "Values" $appSection "resources" | toYaml | nindent 12 }}
          securityContext:
            allowPrivilegeEscalation: false
            runAsNonRoot: true
            runAsUser: 1001
            capabilities:
              drop: [ "all" ]
{{/*          readinessProbe: {{include "lkod.readinessProbe" (list . $appSection) | nindent 12 }}*/}}
{{/*          livenessProbe: {{include "lkod.livenessProbe" (list . $appSection) | nindent 12 }}*/}}
{{ end }}
